#!/usr/bin/env python

"""
A control agent for SignServer
        
"""

"""
RCSid:
	$Id: signctl.py,v 1.7 2013/04/12 20:23:15 sjg Exp $

	@(#) Copyright (c) 2012 Simon J. Gerraty

	This file is provided in the hope that it will
	be of use.  There is absolutely NO WARRANTY.
	Permission to copy, redistribute or otherwise
	use this file is hereby granted provided that 
	the above copyright notice and this notice are
	left intact. 
      
	Please send copies of changes and bug-fixes to:
	sjg@crufty.net

"""

if __name__ == '__main__':
    import sys, socket
    import getopt
    from sign import *

    Myname = basename(sys.argv[0], '.py')
    Mydir = os.path.dirname(sys.argv[0])

    conf = {}

    myconf = Myname + '.cf'
    for d in [Mydir, '.']:
        cf = d + '/' + myconf
        if os.path.exists(cf):
            conf = loadConfig(cf, conf)

    debug = 0
    tries = 2
    opts,args = getopt.getopt(sys.argv[1:], 'dc:r:u:')
    for o,a in opts:
        if o == '-c':
            conf = loadConfig(a, conf)
        elif o == '-d':
            debug += 1
        elif o == '-r':
            tries = int(a)
        elif o == '-u':
            conf['url'] = a

    url = getConfig(conf, 'url')
    if not url:
        # perhaps we got the server's config.
        p = getConfig(conf, 'ListenPort')
        if p:
            url = ':'+p

    sock_family,connect_to = url2sock_address(url)

    sock,msg = urlconnect(sock_family, connect_to, tries)
    if not sock:
        sys.stderr.write(msg+'\n')
        sys.exit(1)
        
    for cmd in args:
        sock.send('signctl: {0}\n'.format(cmd))
        msg = sock.recv(1024)

        if not msg:
            break
        
        if msg.startswith('ERROR'):
            sys.stderr.write(msg+'\n')
            sys.exit(1)
        print msg
        
